config/routes.rb
require 'sidekiq/web'

Rails.application.routes.draw do
  devise_for :users, controllers: { registrations: 'users/registrations' }

  resources :projects
  get 'home/index'

  # authenticated do
    root to: 'projects#index'
  # end

  # root to: 'home#index'

  mount Sidekiq::Web => '/sidekiq'
end

app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/author.rb
# frozen_string_literal: true

class Author < ApplicationRecord
  has_many :commits, dependent: :destroy

  validates :name, :email, presence: true
end

app/models/branch.rb
# frozen_string_literal: true

class Branch < ApplicationRecord
  has_many :commits, -> { order(id: :desc) }, dependent: :destroy
  belongs_to :project
end

app/models/commit.rb
# frozen_string_literal: true

class Commit < ApplicationRecord
  has_many :branches
  belongs_to :author

  validates :sha, uniqueness: { scope: :branch_id }
end

app/models/project.rb
# frozen_string_literal: true

class Project < ActiveRecord::Base
  has_many :branches, dependent: :destroy
  has_many :commits, -> { order(id: :desc) }, through: :branches

  validates :ref, uniqueness: true
  validates :name, :description, :ref, presence: true
  validates :name, :description, :ref, length: { maximum: 255 }
end

app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  enum role: { regular: 'regular', manager: 'manager' }

  has_attached_file :avatar, styles: { medium: '300x300>', thumb: '32x32>' }, default_url: '/images/:style/missing.png'
  validates_attachment_content_type :avatar, content_type: %r{\Aimage/.*\z}

  def full_name
    "#{first_name} #{last_name}"
  end
end

app/controllers/application_controller.rb
# frozen_string_literal: true

require 'application_responder'

class ApplicationController < ActionController::Base
  self.responder = ApplicationResponder
  respond_to :html, :json
end

app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController
  def index; end
end

app/controllers/projects_controller.rb
# frozen_string_literal: true

class ProjectsController < ApplicationController
  before_action :current_project, only: %i[show edit update destroy]
  before_action :authenticate_user!, only: %i[new create edit update destroy]
  respond_to :html, :json

  def index
    @projects = Project.all
    respond_with(@projects)
  end

  def show
    @data = ChartData.call(project: current_project)
    respond_with(current_project)
  end

  def new
    @current_project = Project.new
  end

  def create
    @current_project = Project.create(project_params)
    LogLoadingJob.perform_later(@current_project)

    respond_with(@current_project)
  end

  def edit; end

  def update
    current_project.update(project_params)

    respond_to do |format|
      format.html { respond_with(current_project) }
      format.json { respond_with(current_project, json: current_project) }
    end
  end

  def destroy
    current_project.destroy
    respond_with(current_project)
  end

  private

  def current_project
    @current_project ||= Project.find(params[:id])
  end

  def project_params
    params.require(:project).permit(:name, :description, :ref)
  end
end

app/controllers/users/registrations_controller.rb
# frozen_string_literal: true

class Users::RegistrationsController < Devise::RegistrationsController
  before_action :configure_sign_up_params, only: [:create]
  before_action :configure_account_update_params, only: [:update]

  protected

  # If you have extra params to permit, append them to the sanitizer.
  def configure_sign_up_params
    devise_parameter_sanitizer.permit(:sign_up, keys: %i[avatar first_name last_name role])
  end

  # If you have extra params to permit, append them to the sanitizer.
  def configure_account_update_params
    devise_parameter_sanitizer.permit(:account_update, keys: %i[avatar first_name last_name role])
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

app/views/layouts/_header.erb
<header style="margin:0 0 30px 0;">
  <!-- Navigation -->
  <nav class="navbar navbar-expand-lg navbar-dark bg-dark static-top">

    <div class="container">
      <%= link_to "PMP", root_path, style: "color:white;", class: "navbar-brand" %>

      <% if user_signed_in? %>
      <ul class="navbar-nav">
        <li class="dropdown">
          <%= image_tag current_user.avatar.url(:thumb) %>
          <%= link_to current_user.full_name, "#", data: {toggle: "dropdown"}, class: "dropdown-toggle", style: "color:white;" %>
          <ul class="dropdown-menu dropdown-menu-right">
            <li class="icon icon-search">
              <%= link_to "Profile", edit_user_registration_path, class:"dropdown-item" %>
            </li>
            <li>
              <%= link_to "Sing out", destroy_user_session_path, method: :delete, class:"dropdown-item" %>
            </li>
          </ul>
        </li>
      </ul>
      <% else %>
      <%= link_to "Sign in", user_session_path, style: "color:white;" %>
      <% end %>
      
    </div>
  </nav>
</header>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Pmp</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render('layouts/header') %>
    <%= yield %>
  </body>
</html>

app/views/projects/_form.html.erb
<%= form_for(@current_project) do |form| %>
<div class="form-group">
  <%= form.label :name %><br/>
  <%= form.text_field :name, autocomplete: "name", class: "form-control" %>
</div>
<div class="form-group">
  <%= form.label :description %><br/>
  <%= form.text_field :description, autocomplete: "name", class: "form-control" %>
</div>
<div class="form-group">
  <%= form.label :ref %><br/>
  <%= form.text_field :ref, autocomplete: "name", class: "form-control" %>
</div>
<div class="actions">
  <%= form.submit class: "btn btn-primary" %>
</div>
<% end %>

app/views/projects/edit.html.erb
<div class="container">
  <div class="row justify-content-md-center">
    <div class="col col-md-3">
      <div class="text-center">
        <h3>Editing project</h3>
        <p id="notice" style="color: red;"><%= alert %></p>
      </div>
      <%= render 'form' %><br/>
      <%= link_to 'Back', projects_path %>
    </div>
  </div>
</div>

app/views/projects/index.html.erb
<div class="container">
  <div class="row justify-content-md-center">
    <div class="col col-md-12">
      <div class="text-center">
        <h3>Projects</h3></br>
      </div>
      <table class="table table-borderedless">     
        <thead>
          <tr>
            <th scope="col">Name</th>
            <th scope="col">Description</th>
            <th scope="col">Reference</th>
            <% if current_user %>
            <th scope="col" colspan="2"></th>
            <% end %>
          </tr>
        </thead>
        <tbody>
          <% @projects.each do |project| %>
          <tr>
            <td><%= link_to project.name, project_path(project), style:"color:black;" %></td>
            <td><%= link_to project.description, project_path(project), style:"color:black;" %></td>
            <td><%= link_to project.ref, project_path(project), style:"color:black;" %></td>

            <% if current_user %>
            <td style="width: 33px;"> <%= link_to 'Edit', edit_project_path(project), style:"color:blue;" %> </td>
            <td style="width: 33px;"> <%= link_to 'Destroy', project, method: :delete, style:"color:red;",data: { confirm: 'Are you sure?' } %></td>
            <% end %>
          </tr>
          <% end %>
        </tbody>
      </table>      
    </br>
    <%= link_to 'New project', new_project_path, class: "btn btn-success" %>
  </div>
</div>
</div>

app/views/projects/new.html.erb
<div class="container">
  <div class="row justify-content-md-center">
    <div class="col col-md-3">
      <div class="text-center">
        <h3>New project</h3>
        <p id="notice" style="color: red;"><%= alert %></p>
      </div>
      <%= render 'form' %><br/>
      <%= link_to 'Back', projects_path %>
    </div>
  </div>
</div>

app/views/projects/show.html.erb
<div class="container">
  <div class="row justify-content-md-center">
    <div class="col col-md-3">
      <div class="text-center">
        <p id="notice" style="color: lightgreen"><%= notice %></p>
      </div>
      <p>
        <strong>Name:</strong>
        <%= @current_project.name %>
      </p>
      <p>
        <strong>Description:</strong>
        <%= @current_project.description %>
      </p>
      <p>
        <strong>Ref:</strong>
        <%= @current_project.ref %>
      </p>
      <%= link_to 'Edit', edit_project_path(@current_project) %> |
      <%= link_to 'Back', projects_path %>
    </div>
  </div>
  <% if @data[:datasets].present? %>
    <div style="margin:30px;">
      <%= line_chart @data, {width: 900, height: 300} %>
    </div>
  <% end %>
</div>